


var Buffer = require('safer-buffer').Buffer
var httpClient = require('request');



module.exports = function (request, callback) {

	var method = request.method.toLowerCase() || 'get';
	var url = request.url || 'https://api.nxtgen.online';
	var api = request.api;
	var version = request.version || 1;
	var auth = JSON.stringify(request.auth) || {};

	var httpRequest = {
		method : method,
		headers : {
			'Nxtgen-Api' : api,
			'Nxtgen-Api-Version' : version,
			'Nxtgen-Auth' : Buffer.from(auth,'utf8').toString('base64')
		},
		uri : url,
		qs : request.params,
		body : request,
		json : true
	};

	if (method === 'get') {
		httpRequest.uri = url + '/' + api.replace(/\./g,'-') + '/';
		delete httpRequest.body;
	}

	if (method === 'post') {
		delete httpRequest.qs;
	}

	httpClient(httpRequest, function(error, response, body) {

		if (error) {
			console.log(error);
			return callback({
				error : 'API Network Error'
			});
		}

		if (!body) {
			return callback({
				error : 'No Data Returned'
			});
		}

		return callback(body);

	});

}
