


module.exports = function finalizeUpload(uploadID) {

	var upload = nxtgen.$db.get('up-uploads-' + uploadID);

	nxtgen.api.request({
		url : upload.api.url || nxtgen.config.api.url,
		method : 'post',
		api : 'media.finalizeMediaFile',
		params : {
			mediaFileID : upload.mediaFileID
		},
		auth : upload.auth
	}, function(result) {

		if (result.error) {

			upload.status = 'error';
			upload.error = result.error;
			nxtgen.$db.del('up-uploads-' + upload.id);
			nxtgen.$db.del('up-uploaders-' + upload.id);

			return upload.onError(upload);

		}

		upload.status = 'complete';
		upload.mediaFile = result.data;

		nxtgen.$db.del('up-uploads-' + upload.id);
		nxtgen.$db.del('up-uploaders-' + upload.id);

		return upload.onComplete(upload);

	});

}
