


module.exports = function initializeUpload(uploadID) {

	var upload = nxtgen.$db.get('up-uploads-' + uploadID);

	var params = {
		fileID : upload.fileID,
		mediaFile : {
			name : upload.mediaFile.name,
			size : upload.mediaFile.size
		}
	};


	nxtgen.api.request({
		method : 'post',
		url : upload.api.url || nxtgen.config.api.url,
		api : 'media.initiateMediaFile',
		params : params,
		auth : upload.auth
	}, function(result) {

		if (result.error) {
			upload.status = 'error';
			upload.error = result.error;
			nxtgen.$db.del('up-uploads-' + upload.id);
			if (upload.onError) upload.onError(upload);
			return;
		}

		upload.status = 'initialized';

		var mediaFile = result.data;

		upload.mediaFileID = mediaFile._id;
		upload.url = mediaFile.url;
		upload.key = mediaFile.key;
		upload.ext = mediaFile.ext;
		upload.credentials = mediaFile.credentials;

		nxtgen.$db.set('up-uploads-' + upload.id, upload);

		upload.onInit(upload);

		return nxtgen.up.uploadFile(upload.id);

	});

}
