


var AWS = require('aws-sdk');



module.exports = function uploadFile(uploadID) {

	var upload = nxtgen.$db.get('up-uploads-'+ uploadID);

	var bucket = upload.bucket || 'cdn.nxtgen.online';

	var credentials = new AWS.Credentials({
		accessKeyId : upload.credentials.AccessKeyId,
		secretAccessKey : upload.credentials.SecretAccessKey,
		sessionToken : upload.credentials.SessionToken
	});

	AWS.config.region = 'us-east-1';

	var s3 = new AWS.S3({
		credentials : credentials,
		maxRetries : 100,
		params : {
			Bucket : bucket
		}
	});

	nxtgen.$db.set('up-uploaders-' + upload.id, s3.upload({
		Key : upload.key,
		ACL : 'private',
		ContentType : upload.mediaFile.type,
		ContentLength : upload.mediaFile.size,
		Body : upload.mediaFile.buffer,
		ServerSideEncryption : 'AES256'
	}));

	nxtgen.$db.get('up-uploaders-' + upload.id).on('httpUploadProgress', function(event) {

		var total = event.total;
		var loaded = event.loaded;
		var percent = loaded / total * 100;

		var now = new Date().getTime();
		var started = upload.date.initiated;
		var elapsed = now - started;
		var rate = '0Mbps';
		var remaining = '0:00:00';

		upload.status = 'uploading';
		upload.loaded = loaded;
		upload.total = total;
		upload.percent = percent;
		upload.rate = rate;
		upload.remaining = remaining;

		nxtgen.$db.set('up-uploads-' + uploadID, upload);

		return upload.onProgress(upload);

	});

	nxtgen.$db.get('up-uploaders-' + upload.id).send(function(error, result) {

		if (error) {
			upload.status = 'error';
			upload.error = error;
			console.error('[nxtgen-node-client] Upload error, please try again.');
			console.error(error);
			nxtgen.$db.del('up-uploads-' + upload.id);
			nxtgen.$db.del('up-uploaders-' + upload.id);
			upload.onError(upload);
		} else {
			upload.status = 'uploaded';
		}

		nxtgen.$db.set('up-uploads-' + upload.id, upload);

		return nxtgen.up.finalizeUpload(upload.id);

	});

}
